#include "iic.h" 
#include "main.h"
#include "delay.h"




ComTypeDef IIC_COM[5];

void COM_Config() //ӿIICţ˿
{
	
IIC_COM[0].SDA_PIN=IIC_SDA_0_Pin;
IIC_COM[0].SCL_PIN=IIC_SCL_0_Pin;
IIC_COM[0].SDA_PORT=IIC_SDA_0_GPIO_Port;
IIC_COM[0].SCL_PORT=IIC_SCL_0_GPIO_Port;
	
IIC_COM[1].SDA_PIN=IIC_SDA_1_Pin;
IIC_COM[1].SCL_PIN=IIC_SCL_12_Pin;
IIC_COM[1].SDA_PORT=IIC_SDA_1_GPIO_Port;
IIC_COM[1].SCL_PORT=IIC_SCL_12_GPIO_Port;
	
IIC_COM[2].SDA_PIN=IIC_SDA_2_Pin;
IIC_COM[2].SCL_PIN=IIC_SCL_12_Pin;
IIC_COM[2].SDA_PORT=IIC_SDA_2_GPIO_Port;
IIC_COM[2].SCL_PORT=IIC_SCL_12_GPIO_Port;
	
IIC_COM[3].SDA_PIN=IIC_SDA_3_Pin;
IIC_COM[3].SCL_PIN=IIC_SCL_34_Pin;
IIC_COM[3].SDA_PORT=IIC_SDA_3_GPIO_Port;
IIC_COM[3].SCL_PORT=IIC_SCL_34_GPIO_Port;
	
IIC_COM[4].SDA_PIN=IIC_SDA_4_Pin;
IIC_COM[4].SCL_PIN=IIC_SCL_34_Pin;
IIC_COM[4].SDA_PORT=IIC_SDA_4_GPIO_Port;
IIC_COM[4].SCL_PORT=IIC_SCL_34_GPIO_Port;
		

}







void SDA_Pin_Output_High(ComTypeDef IIC_COM)   //SDAΪ© Ϊߵƽ
{
	GPIO_InitTypeDef GPIO_InitStruct;
  GPIO_InitStruct.Pin = IIC_COM.SDA_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(IIC_COM.SDA_PORT, &GPIO_InitStruct);
	HAL_GPIO_WritePin(IIC_COM.SDA_PORT, IIC_COM.SDA_PIN, GPIO_PIN_SET);
}

void SDA_Pin_Output_Low(ComTypeDef IIC_COM)  //SDAΪ©  Ϊ͵ƽ
{

	GPIO_InitTypeDef GPIO_InitStruct;
  GPIO_InitStruct.Pin = IIC_COM.SDA_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(IIC_COM.SDA_PORT, &GPIO_InitStruct);
	HAL_GPIO_WritePin(IIC_COM.SDA_PORT, IIC_COM.SDA_PIN, GPIO_PIN_RESET);
}

void SDA_Pin_INPUT(ComTypeDef IIC_COM)  //SDAΪ
{

	GPIO_InitTypeDef GPIO_InitStruct;
  GPIO_InitStruct.Pin = IIC_COM.SDA_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(IIC_COM.SDA_PORT, &GPIO_InitStruct);

}

void SCL_Pin_Output_High(ComTypeDef IIC_COM) //SCLΪ©Ϊߵƽ
{
	GPIO_InitTypeDef GPIO_InitStruct;
  GPIO_InitStruct.Pin = IIC_COM.SCL_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(IIC_COM.SCL_PORT, &GPIO_InitStruct);
	HAL_GPIO_WritePin(IIC_COM.SCL_PORT, IIC_COM.SCL_PIN, GPIO_PIN_SET);
}

void SCL_Pin_Output_Low(ComTypeDef IIC_COM) //SCLΪ©͵ƽ
{
	GPIO_InitTypeDef GPIO_InitStruct;
  GPIO_InitStruct.Pin = IIC_COM.SCL_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(IIC_COM.SCL_PORT, &GPIO_InitStruct);
	HAL_GPIO_WritePin(IIC_COM.SCL_PORT, IIC_COM.SCL_PIN, GPIO_PIN_RESET);
}

void Init_IIC_Sensor_Port(ComTypeDef IIC_COM) //ʼIICӿ,Ϊߵƽ
{	
SDA_Pin_Output_High(IIC_COM);
SCL_Pin_Output_High(IIC_COM);
}
void IIC_Start(ComTypeDef IIC_COM)		 //IICSTARTź
{
	SDA_Pin_Output_High(IIC_COM);
	IIC_delay;
	SCL_Pin_Output_High(IIC_COM);
	IIC_delay;
	SDA_Pin_Output_Low(IIC_COM);
	IIC_delay;
	SCL_Pin_Output_Low(IIC_COM);
	IIC_delay;   
}


void IIC_WR_Byte(uint8_t Byte,ComTypeDef IIC_COM) //IICдһֽ
{
	uint8_t Data,N,i;	
	Data=Byte;
	i = 0x80;
	for(N=0;N<8;N++)
	{
		SCL_Pin_Output_Low(IIC_COM); 
		IIC_delay;	
		if(i&Data)
		{
			SDA_Pin_Output_High(IIC_COM);
		}
		else
		{
			SDA_Pin_Output_Low(IIC_COM);
		}	
			
    SCL_Pin_Output_High(IIC_COM);
		IIC_delay;
		Data <<= 1;
		 
	}
	SCL_Pin_Output_Low(IIC_COM);
	IIC_delay;   
	SDA_Pin_INPUT(IIC_COM);
	IIC_delay;
	
}	




uint8_t IIC_RD_Byte(ComTypeDef IIC_COM)//IICȡһֽ
{
	uint8_t Byte,i,a;
	Byte = 0;
	SCL_Pin_Output_Low(IIC_COM);
	SDA_Pin_INPUT(IIC_COM);
	IIC_delay;	
	for(i=0;i<8;i++)
	{
    SCL_Pin_Output_High(IIC_COM);		
		IIC_delay;
		a=0;
		if(HAL_GPIO_ReadPin(IIC_COM.SDA_PORT, IIC_COM.SDA_PIN)) a=1;
		Byte = (Byte<<1)|a;
		SCL_Pin_Output_Low(IIC_COM);
		IIC_delay;
	}
  SDA_Pin_INPUT(IIC_COM);
	IIC_delay;	
	return Byte;
}



uint8_t Receive_ACK(ComTypeDef IIC_COM)   //ACK,Ӧ𣬷1
{
	uint16_t CNT;
	CNT = 0;
	SCL_Pin_Output_Low(IIC_COM);	
	SDA_Pin_INPUT(IIC_COM);
	IIC_delay;	
	SCL_Pin_Output_High(IIC_COM);	
	IIC_delay;	
	while((HAL_GPIO_ReadPin(IIC_COM.SDA_PORT, IIC_COM.SDA_PIN))  && CNT < 100) 
	CNT++;
	if(CNT == 100)
	{
		return 1;//Ӧ
	}
 	SCL_Pin_Output_Low(IIC_COM);	
	IIC_delay;	
	return 0;
}

void Send_ACK(ComTypeDef IIC_COM)		  //ظACKź
{
	SCL_Pin_Output_Low(IIC_COM);	
	IIC_delay;	
	SDA_Pin_Output_Low(IIC_COM);
	IIC_delay;	
	SCL_Pin_Output_High(IIC_COM);	
	IIC_delay;
	SCL_Pin_Output_Low(IIC_COM);	
	IIC_delay;
	SDA_Pin_INPUT(IIC_COM);
	IIC_delay;
}

void Send_NOT_ACK(ComTypeDef IIC_COM)	//ظACK
{
	SCL_Pin_Output_Low(IIC_COM);	
	IIC_delay;
	SDA_Pin_Output_High(IIC_COM);
	IIC_delay;
	SCL_Pin_Output_High(IIC_COM);	
	IIC_delay;		
	SCL_Pin_Output_Low(IIC_COM);	
	IIC_delay;
    SDA_Pin_Output_Low(IIC_COM);
	IIC_delay;
}

void IIC_Stop(ComTypeDef IIC_COM)	  //һЭ
{
	SDA_Pin_Output_Low(IIC_COM);
	IIC_delay;
	SCL_Pin_Output_High(IIC_COM);	
	IIC_delay;
	SDA_Pin_Output_High(IIC_COM);
	IIC_delay;
}






u8 Calc_CRC8(u8 *dat, u8 Num)
{
	u8 i,byte,crc=0xFF;
	for(byte=0; byte<Num; byte++)
	{
		crc^=(dat[byte]);
		for(i=0;i<8;i++)
		{
			if(crc & 0x80) crc=(crc<<1)^0x31;
			else crc=(crc<<1);
		}
	}
	return crc;
}





