#ifndef _AHT20_DEMO_
#define _AHT20_DEMO_

#include "stm32g0xx.h"  
#include "delay.h"


#define IIC_delay delay_us(20)




typedef struct
{
  uint16_t SDA_PIN;        
	uint16_t SCL_PIN;
	GPIO_TypeDef * SDA_PORT;
	GPIO_TypeDef * SCL_PORT;
} ComTypeDef;








void COM_Config(void);

void SDA_Pin_Output_High(ComTypeDef IIC_COM);   //SDAΪ© Ϊߵƽ

void SDA_Pin_Output_Low(ComTypeDef IIC_COM);  //SDAΪ©  Ϊ͵ƽ

void SDA_Pin_INPUT(ComTypeDef IIC_COM);  //SDAΪ

void SCL_Pin_Output_High(ComTypeDef IIC_COM); //SCLߵƽ

void SCL_Pin_Output_Low(ComTypeDef IIC_COM); //SCL͵ƽ

void Init_IIC_Sensor_Port(ComTypeDef IIC_COM); //ʼIICӿ,Ϊߵƽ

void IIC_Start(ComTypeDef IIC_COM);		 //IICSTARTź

void IIC_WR_Byte(uint8_t Byte,ComTypeDef IIC_COM); //IICдһֽ

uint8_t IIC_RD_Byte(ComTypeDef IIC_COM);//IICȡһֽ

uint8_t Receive_ACK(ComTypeDef IIC_COM);   //ACK

void Send_ACK(ComTypeDef IIC_COM);		  //ظACKź

void Send_NOT_ACK(ComTypeDef IIC_COM);	//ظACK

void IIC_Stop(ComTypeDef IIC_COM);	  //һЭ

u8 Calc_CRC8(u8 *dat, u8 Num);





#endif

